/*
   Hyllian's 3xBR v3.3b
   
   Copyright (C) 2011, 2012 Hyllian/Jararaca - sergiogdb@gmail.com

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

//---------------------------------------------------------------------------------------------------------------------------
// 3xBR-v3.3b plugin for Kega Fusion.
// Programmed by Hyllian
//---------------------------------------------------------------------------------------------------------------------------

#include "dll.h"
#include <stdlib.h>

//---------------------------------------------------------------------------------------------------------------------------

extern "C"
{
    static unsigned char initialized = 0;
	unsigned int	RGBtoYUV[65536];
    static unsigned int tbl_5_to_8[32]={0, 8, 16, 25, 33, 41, 49,  58, 66, 74, 82, 90, 99, 107, 115, 123, 132, 140, 148, 156, 165, 173, 181, 189,  197, 206, 214, 222, 230, 239, 247, 255};
    static unsigned int tbl_6_to_8[64]={0, 4, 8, 12, 16, 20, 24,  28, 32, 36, 40, 45, 49, 53, 57, 61, 65, 69, 73, 77, 81, 85, 89, 93, 97, 101,  105, 109, 113, 117, 121, 125, 130, 134, 138, 142, 146, 150, 154, 158, 162, 166,  170, 174, 178, 182, 186, 190, 194, 198, 202, 206, 210, 215, 219, 223, 227, 231,  235, 239, 243, 247, 251, 255};
}

//---------------------------------------------------------------------------------------------------------------------------


unsigned short int pg_red_mask;
unsigned short int pg_green_mask;
unsigned short int pg_blue_mask;
unsigned short int pg_lbmask;

#define RED_MASK565   0xF800
#define GREEN_MASK565 0x07E0
#define BLUE_MASK565  0x001F

#define RED_MASK555 0x7C00
#define GREEN_MASK555 0x03E0
#define BLUE_MASK555 0x001F

#define PG_LBMASK565 0xF7DE
#define PG_LBMASK555 0x7BDE


#define ALPHA_BLEND_128_W(dst, src) dst = ((src & pg_lbmask) >> 1) + ((dst & pg_lbmask) >> 1)

#define ALPHA_BLEND_32_W(dst, src) \
	dst = ( \
    (pg_red_mask & ((dst & pg_red_mask) + \
        ((((src & pg_red_mask) - \
        (dst & pg_red_mask))) >>3))) | \
    (pg_green_mask & ((dst & pg_green_mask) + \
        ((((src & pg_green_mask) - \
        (dst & pg_green_mask))) >>3))) | \
    (pg_blue_mask & ((dst & pg_blue_mask) + \
        ((((src & pg_blue_mask) - \
        (dst & pg_blue_mask))) >>3))) )

#define ALPHA_BLEND_64_W(dst, src) \
	dst = ( \
    (pg_red_mask & ((dst & pg_red_mask) + \
        ((((src & pg_red_mask) - \
        (dst & pg_red_mask))) >>2))) | \
    (pg_green_mask & ((dst & pg_green_mask) + \
        ((((src & pg_green_mask) - \
        (dst & pg_green_mask))) >>2))) | \
    (pg_blue_mask & ((dst & pg_blue_mask) + \
        ((((src & pg_blue_mask) - \
        (dst & pg_blue_mask))) >>2))) )

#define ALPHA_BLEND_192_W(dst, src) \
	dst = ( \
    (pg_red_mask & ((dst & pg_red_mask) + \
        ((((src & pg_red_mask) - \
        (dst & pg_red_mask)) * 192) >>8))) | \
    (pg_green_mask & ((dst & pg_green_mask) + \
        ((((src & pg_green_mask) - \
        (dst & pg_green_mask)) * 192) >>8))) | \
    (pg_blue_mask & ((dst & pg_blue_mask) + \
        ((((src & pg_blue_mask) - \
        (dst & pg_blue_mask)) * 192) >>8))) )
        
#define ALPHA_BLEND_224_W(dst, src) \
	dst = ( \
    (pg_red_mask & ((dst & pg_red_mask) + \
        ((((src & pg_red_mask) - \
        (dst & pg_red_mask)) * 224) >>8))) | \
    (pg_green_mask & ((dst & pg_green_mask) + \
        ((((src & pg_green_mask) - \
        (dst & pg_green_mask)) * 224) >>8))) | \
    (pg_blue_mask & ((dst & pg_blue_mask) + \
        ((((src & pg_blue_mask) - \
        (dst & pg_blue_mask)) * 224) >>8))) );


#define LEFT_UP_2_3X(N7, N5, N6, N2, N8, PIXEL)\
             ALPHA_BLEND_192_W(E[N7], PIXEL); \
             ALPHA_BLEND_64_W( E[N6], PIXEL); \
             E[N5] = E[N7]; \
             E[N2] = E[N6]; \
             E[N8] =  PIXEL;\

        
#define LEFT_2_3X(N7, N5, N6, N8, PIXEL)\
             ALPHA_BLEND_192_W(E[N7], PIXEL); \
             ALPHA_BLEND_64_W( E[N5], PIXEL); \
             ALPHA_BLEND_64_W( E[N6], PIXEL); \
             E[N8] =  PIXEL;\

#define UP_2_3X(N5, N7, N2, N8, PIXEL)\
             ALPHA_BLEND_192_W(E[N5], PIXEL); \
             ALPHA_BLEND_64_W( E[N7], PIXEL); \
             ALPHA_BLEND_64_W( E[N2], PIXEL); \
             E[N8] =  PIXEL;\

#define DIA_3X(N8, N5, N7, PIXEL)\
             ALPHA_BLEND_224_W(E[N8], PIXEL); \
             ALPHA_BLEND_32_W(E[N5], PIXEL); \
             ALPHA_BLEND_32_W(E[N7], PIXEL); \


#define df(A, B)\
        abs(RGBtoYUV[A] - RGBtoYUV[B])\

#define eq(A, B)\
        (df(A, B) < 155)\


#define FILTRO(PE, PI, PH, PF, PG, PC, PD, PB, PA, G5, C4, G0, D0, C1, B1, F4, I4, H5, I5, A0, A1, N0, N1, N2, N3, N4, N5, N6, N7, N8) \
     ex   = (PE!=PH && PE!=PF); \
     if ( ex )\
     {\
          e = (df(PE,PC)+df(PE,PG)+df(PI,H5)+df(PI,F4))+(df(PH,PF)<<2); \
          i = (df(PH,PD)+df(PH,I5)+df(PF,I4)+df(PF,PB))+(df(PE,PI)<<2); \
          if ((e<i) && ( !eq(PF,PB) && !eq(PH,PD) || eq(PE,PI) && (!eq(PF,I4) && !eq(PH,I5)) || eq(PE,PG) || eq(PE,PC)) )\
          {\
              ke=df(PF,PG); ki=df(PH,PC); \
              ex2 = (PE!=PC && PB!=PC); ex3 = (PE!=PG && PD!=PG); px = (df(PE,PF) <= df(PE,PH)) ? PF : PH; \
              if ( ((ke<<1)<=ki) && ex3 && (ke>=(ki<<1)) && ex2 ) \
              {\
                     LEFT_UP_2_3X(N7, N5, N6, N2, N8, px)\
              }\
              else if ( ((ke<<1)<=ki) && ex3 ) \
              {\
                     LEFT_2_3X(N7, N5, N6, N8, px);\
              }\
              else if ( (ke>=(ki<<1)) && ex2 ) \
              {\
                     UP_2_3X(N5, N7, N2, N8, px);\
              }\
              else \
              {\
                     DIA_3X(N8, N5, N7, px);\
              }\
          }\
          else if (e<=i)\
          {\
               ALPHA_BLEND_128_W( E[N8], ((df(PE,PF) <= df(PE,PH)) ? PF : PH)); \
          }\
     }\

        

//---------------------------------------------------------------------------------------------------------------------------

extern	"C"	__declspec(dllexport) RENDER_PLUGIN_INFO *
RenderPluginGetInfo(void)
{
	rpi_strcpy(&MyRPI.Name[0], "3xBR - v3.3b (Hyllian/Jararaca)");
	MyRPI.Flags=RPI_VERSION | RPI_555_SUPP | RPI_565_SUPP | RPI_OUT_SCL3;
	return(&MyRPI);
}

//---------------------------------------------------------------------------------------------------------------------------

extern "C"	void
SetupFormat(unsigned char format)
{
    unsigned int c, r, g, b, y, u, v;

    if(format==0)	//565
    {
         for (c = 0; c < 65536; c++)
         {
              r = tbl_5_to_8[(c &   RED_MASK565) >> 11];
              g = tbl_6_to_8[(c & GREEN_MASK565) >>  5];
              b = tbl_5_to_8[(c &  BLUE_MASK565)      ];
              y = ((r<<4) + (g<<5) + (b<<2));
              u = (   -r  - (g<<1) + (b<<2));
              v = ((r<<1) - (g<<1) - (b>>1));
              RGBtoYUV[c] = y + u + v;
         }
    }
	else if(format==1)	//555
	{
        for (c = 0; c < 65536; c++) {
              r = tbl_5_to_8[(c &   RED_MASK555) >> 10];
              g = tbl_5_to_8[(c & GREEN_MASK555) >>  5];
              b = tbl_5_to_8[(c &  BLUE_MASK555)      ];
              y = ((r<<4) + (g<<5) + (b<<2));
              u = (   -r  - (g<<1) + (b<<2));
              v = ((r<<1) - (g<<1) - (b>>1));
              RGBtoYUV[c] = y + u + v;
         }
 	}
}

//---------------------------------------------------------------------------------------------------------------------------

extern	"C"	__declspec(dllexport) void
RenderPluginOutput(RENDER_PLUGIN_OUTP *rpo)
{	
	unsigned short int x, y;
	unsigned char *src, *dest;
	unsigned short int PA, PB, PC, PD, PE, PF, PG, PH, PI;
	unsigned short int A0, D0, G0, A1, B1, C1, C4, F4, I4, G5, H5, I5;
	register unsigned short int *sa1, *sa2, *sa3; // sa = start_address
	register unsigned short int *sa0, *sa4;
	unsigned short int nl, nl_src; // nl = new_line
    unsigned short int nl1;	
	unsigned short int *E;  // E = dst_pixel
	unsigned short int src_width, src_height;
	unsigned short int complete_line_src, complete_line_dst;
	unsigned short int src_pitch;
	unsigned char pprev, pprev2;	
    unsigned short int px;
    unsigned int e, i, p[10];
    unsigned char ex, ex2, ex3;
    unsigned int ke, ki;


    if (!initialized)
    {
       if(rpo->Flags&RPI_565_SUPP)
       {
              	 pg_red_mask   = RED_MASK565;
                 pg_green_mask = GREEN_MASK565;
                 pg_blue_mask  = BLUE_MASK565;
                 pg_lbmask     = PG_LBMASK565;
                 SetupFormat(0);
       }
       else if(rpo->Flags&RPI_555_SUPP)
       {
	             pg_red_mask   = RED_MASK555;
	             pg_green_mask = GREEN_MASK555;
        	     pg_blue_mask  = BLUE_MASK555;
        	     pg_lbmask     = PG_LBMASK555;
                 SetupFormat(1);
       }
       initialized = 1;
    }
	
	/* Don't blit anything if we don't have enough screen space */
   if(!(((rpo->SrcW * 3)<=rpo->DstW) && ((rpo->SrcH * 3)<=rpo->DstH)))
		return;

	src = (unsigned char *)rpo->SrcPtr;	
	dest = (unsigned char *)rpo->DstPtr;
	src_pitch = rpo->SrcPitch;

	nl_src = src_pitch >> 1;
	nl = rpo->DstPitch >> 1;
	nl1= rpo->DstPitch;

	src_width = rpo->SrcW;
	src_height = rpo->SrcH;

	// fixed by Steve Snake
	complete_line_src = (src_pitch>>1) - rpo->SrcW;
	complete_line_dst = ((rpo->DstPitch*3)>>1) - rpo->DstW;
	
	sa2 = (unsigned short int *)(src - 4);
	sa0 = sa1 = sa2;
	sa3 = sa2 + src_pitch;
	sa4 = sa3 + src_pitch;
	
	E = (unsigned short int *)(dest);	
	
	y = src_height;

	while(y--)
	{	
		if (y <= 1) { sa4 = sa3; if (!y) sa4 = sa3 = sa2;}
        		
		pprev = pprev2 = 2;
        
        x = src_width;
		
		while(x--) 
		{			
			B1 = sa0[2];
            PB = sa1[2];
			PE = sa2[2];			
			PH = sa3[2];
			H5 = sa4[2];
			
			A1 = sa0[pprev];
			PA = sa1[pprev];
			PD = sa2[pprev];			
			PG = sa3[pprev];
			G5 = sa4[pprev];
			
			A0 = sa1[pprev2];
			D0 = sa2[pprev2];			
			G0 = sa3[pprev2];

            C1 = sa0[3];
    		PC = sa1[3];
			PF = sa2[3];
			PI = sa3[3];
			I5 = sa4[3];
				
			C4 = sa1[4];
			F4 = sa2[4];
			I4 = sa3[4];

		    if (x <= 1)
			{
 				C4 = sa1[3];
				F4 = sa2[3];
				I4 = sa3[3];
				
                if (!x)				
                {
                    C1 = sa0[2];
    				PC = sa1[2];
    				PF = sa2[2];
    				PI = sa3[2];
	    			I5 = sa4[2];
				
		    		C4 = sa1[2];
	    			F4 = sa2[2];
    				I4 = sa3[2];
    			}
			}

			E[0]   = E[1]     = E[2]     = PE;
			E[nl]  = E[nl+1]  = E[nl+2]  = PE; // 3, 4, 5
			E[nl1] = E[nl1+1] = E[nl1+2] = PE; // 6, 7, 8
			
			
FILTRO(PE, PI, PH, PF, PG, PC, PD, PB, PA, G5, C4, G0, D0, C1, B1, F4, I4, H5, I5, A0, A1, 0, 1, 2, nl, nl+1, nl+2, nl1, nl1+1, nl1+2);
FILTRO(PE, PC, PF, PB, PI, PA, PH, PD, PG, I4, A1, I5, H5, A0, D0, B1, C1, F4, C4, G5, G0, nl1, nl, 0, nl1+1, nl+1, 1, nl1+2, nl+2, 2);
FILTRO(PE, PA, PB, PD, PC, PG, PF, PH, PI, C1, G0, C4, F4, G5, H5, D0, A0, B1, A1, I4, I5, nl1+2, nl1+1, nl1, nl+2, nl+1, nl, 2, 1, 0);
FILTRO(PE, PG, PD, PH, PA, PI, PB, PF, PC, A0, I5, A1, B1, I4, F4, H5, G5, D0, G0, C1, C4, 2, nl+2, nl1+2, 1, nl+1, nl1+1, 0, nl, nl1);

//             ALPHA_BLEND_128_W(E[0], PD); ALPHA_BLEND_128_W(E[1], PD); ALPHA_BLEND_128_W(E[2], PD);
//             ALPHA_BLEND_128_W(E[nl], PD); ALPHA_BLEND_128_W(E[nl+1], PD); ALPHA_BLEND_128_W(E[nl+2], PD);
//             ALPHA_BLEND_128_W(E[nl1], PD); ALPHA_BLEND_128_W(E[nl1+1], PD); ALPHA_BLEND_128_W(E[nl1+2], PD);
             

		    sa0++;
			sa1++;
			sa2++;
			sa3++;
			sa4++;
			
            E+=3;

			
			if (pprev2) {pprev2--; pprev = 1;}
		}

		
        sa2 += complete_line_src;
		sa1 = sa2 - nl_src;		
		sa3 = sa2 + nl_src;
		
		
		if (y == src_height - 1)
		{
            sa0 = sa1;		
		    sa4 = sa3 + nl_src;
        }
        else if (!y)
		{
            sa0 = sa1 - nl_src;		
		    sa4 = sa3;
        }                
        else
        {
            sa0 = sa1 - nl_src;		
		    sa4 = sa3 + nl_src;
        }
                
        E += complete_line_dst;				
	}
	
	// Set the output size incase anybody cares.
	//rpo->OutW=(rpo->SrcW*3);
	//rpo->OutH=(rpo->SrcH*3);
	
}


//---------------------------------------------------------------------------------------------------------------------------
